/**
 * @author Resalat Haque
 * @link http://www.w3bees.com
 */

function pollStatus(last_state, last_progress) {
  $('#heading_progress').hide();
  $('#install_progress2').show();
  document.getElementById("modal").setAttribute("class", "visible");
  
  var action = $('form').attr('action');
  $.post(action, JSON.stringify({
    cmd: 'poll',
    last_progress: last_progress,
    last_state: last_state,
    lang: lang
  }), onUpdateStatus);
}

function onResetComplete(data) {
  // window.location.href = window.location.href;
}

function onUpdateStatus(data) {
  document.getElementById("modal").setAttribute("class", "visible");
  var divBar = $('#install_progress2 > .bar');
  var divPercent = $('#install_progress2 > .percent');
  var divInstall = $('#install_progress2');

  var pVal = data.progress + '%';
  if (data.state == "Download") {
    divBar.width(pVal);
    divPercent.html(msgDownloadingDevicePackage + " - " + pVal);
    pollStatus(data.state, data.progress, data.lang);
  } else if (data.state == "Install") {
    divInstall.show();
    divBar.css("background-color", "#20ff20");
    divBar.width(pVal);
    divPercent.html(msgUpdatingFiles + " - " + pVal);
    pollStatus(data.state, data.progress, data.lang);
  } else if (data.state == "Success") {
    divInstall.show();
    divBar.css("background-color", "#20ff20");
    divPercent.html(msgRestart);
    //setTimeout( startPollReboot, 30000 );
    resetAfterError();
    CreateModalDialog(document.getElementById('heading_progress').childNodes[0].nodeValue, msgRestart + "<br><center><div class=\"spinner\"></div></center>");
    WaitForReload(20000);
  // onUpdateRebootProgress( 0 );
  } else if (data.state == "Error") {
    divInstall.show();
    divBar.width("100%");
    divBar.css("background-color", "red");
    divPercent.html(data.message);
    CreateModalDialogUpload(i18n.translate('firmware_update_error'), "<div><b>" + data.message + "</b><br><br>" + i18n.translate('hint_reboot_after_error') + "</div><br><input type=button value=\"" + document.getElementById('button_reset').value + "\" id=button_reset2 onclick=\"resetAfterError()\"/>");
    document.getElementById("modal").setAttribute("class", "visible");
    $('#button_reset2').show();
  }
}

function onUpdateRebootProgress(percent) {
  var divBar = $('#install_progress2 > .bar');
  divBar.width(percent + "%");
  if (percent < 100) {
    setTimeout(function() {
      onUpdateRebootProgress(percent + 1);
    }, 1400);
  } else {
    location.replace(location.origin);
  }
}

function startLocalUpdate() {
  var divBar = $('#install_progress2 > .bar');
  var divPercent = $('#install_progress2 > .percent');
  var divInstall = $('#install_progress2');

  divInstall.show();
//  $('#heading_progress').show();

  divBar.css("background-color", "#20ff20");
  var action = $('form').attr('action');
  $.post(action, JSON.stringify({
    cmd: 'install'
  }), onUpdateStatus);
}

function startServerUpdate(message) {
  /* variables */
  var divInstall = $('#install_progress2');
  var divBar = $('#install_progress2 > .bar');
  var divPercent = $('#install_progress2 > .percent');
  var buttonUpdate = $('#button_update');

  if (divInstall.is(':visible')) {
    return;
  }

  if (message.length > 0) {
    if (!confirm(message)) {
      return;
    }
  }

  divInstall.show();
  document.getElementById("modal").setAttribute("class", "visible");
  buttonUpdate.disabled = true;
  divPercent.html(msgStartingUpdate);

  divBar.css("background-color", "#20ff20");
  var action = $('form').attr('action');
  $.post(action, JSON.stringify({
    cmd: 'download'
  }), onUpdateStatus);
}

function resetAfterError() {
  var action = $('form').attr('action');
  $.post(action, JSON.stringify({
    cmd: 'reset'
  }), onResetComplete);
  $('#install_progress2').hide();
  $('#heading_progress').hide();
  $('#button_reset2').hide();
  HideModalDialog();
}

function startPollReboot() {
  var action = $('form').attr('action');
  $.ajax({
    type: "POST",
    url: action,
    data: JSON.stringify({
      cmd: 'poll'
    }),
    /* complete call back */
    complete: function(data, status) {
      if (status == "success" && data.responseJSON.state == "Idle") {
        setTimeout(startPollMainPage, 5000);
      } else {
        setTimeout(startPollReboot, 5000);
      }
    }
  });
}

function startPollMainPage() {
  $.ajax({
    type: "GET",
    url: "/",
    /* complete call back */
    complete: function(data, status) {
      if (status == "success") {
        window.location.href = "/";
      } else {
        setTimeout(startPollMainPage, 2000);
      }
    }
  });
}

$(document).ready(function() {

  CreateModalDialogUpload(document.getElementById('heading_progress').childNodes[0].nodeValue, "<div id=\"reboot_after_error\"></div><div class=\"progress\" id=\"install_progress2\"><div class=\"bar\"></div><div class=\"percent\"></div></div><input type=button value=\"" + document.getElementById('button_reset').value + "\" id=button_reset2 onclick=\"resetAfterError()\"/>");
  var percent = $('#install_progress2 > .percent');
  var bar = $('#install_progress2 > .bar');
  /* variables */

  /* submit form with ajax request */
  $('form').ajaxForm({

    /* set data type json */
    dataType: 'json',

    /* reset before submitting */
    beforeSend: function() {
      bar.width('0%');
      percent.html(msgUploadingDevicePackage + " - 0%");
      $('#install_progress2').show();
      document.getElementById("modal").setAttribute("class", "visible");

    },

    /* progress bar call back*/
    uploadProgress: function(event, position, total, percentComplete) {
      $('#install_progress2').show();
      document.getElementById("modal").setAttribute("class", "visible");
      var pVel = percentComplete + '%';
      bar.width(pVel);
      if (percentComplete == 100) {
        percent.html(msgProcessingDevicePackage);
      } else {
        percent.html(msgUploadingDevicePackage + " - " + pVel);
      }
    },

    /* complete call back */
    complete: function(data) {
      $('#install_progress2').show();
      document.getElementById("modal").setAttribute("class", "visible");
      bar.width("100%");
      percent.html(msgUploadingDevicePackageComplete);
      if (data.responseJSON.progress == 100) {
        startLocalUpdate();
      }
    }

  });
});
