#!/usr/bin/tclsh
source ../fwupdate/cgi.tcl

set MNT_PATH "/mnt"
set USBDEV_PATH "/dev/sda1"
set MNT_OPTIONS "-o,ro"
set TESTFILE "testfile.txt"
set TMPDIR  "/tmp"

proc cgi_cgi {args} {return $args}
set _cgi(tmpdir) $TMPDIR

proc umount_usb {} {
	global MNT_PATH
	# try unmount USB
	if [catch {
		exec umount -f $MNT_PATH
	}] {
		# ignore errors
	}
}

cgi_eval {
	# If something is wrong, we have a failure
	set test_result "Unknown Failure"
	if [file exists /etc/config/cgi_debug] {cgi_debug -on}
	
	if {![file isdirectory /sys/bus/usb]} { 
		cgi_put "Device has no USB support!"
		exit -1
	}
	
	# in case the stick is already mounted...
	umount_usb
	# mount USB
	set result ""
	if [catch {
		exec mount $MNT_OPTIONS $USBDEV_PATH $MNT_PATH
	}] {
		cgi_put "Error mounting USB stick!"
		exit -1
	}
	# read testfile
	if [catch {
		set fp [open "$MNT_PATH/$TESTFILE" r]
		set test_result [read $fp]
		close $fp
	}] {
		cgi_put "Error reading the testfile!"
		close $fp
		umount_usb
		exit -1
	}
	umount_usb
	# show success as plain text
	cgi_put $test_result
}

